package com.openkm.workflow;

import org.jbpm.graph.exe.ExecutionContext;
import org.jbpm.taskmgmt.def.AssignmentHandler;
import org.jbpm.taskmgmt.exe.Assignable;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.openkm.api.OKMNote;
import com.openkm.api.OKMRepository;
import com.openkm.dao.ConfigDAO;
import com.openkm.module.db.stuff.DbSessionManager;

public class ActorAssigment implements AssignmentHandler {
	private static final long serialVersionUID = 1L;
	private static Logger log = LoggerFactory.getLogger(ActorAssigment.class);
	private String role;
	
	@Override
	public void assign(Assignable assign, ExecutionContext execContext) throws Exception {
		log.info("assign({}, {})", assign, execContext.getNode().getName());
		String token = DbSessionManager.getInstance().getSystemToken();
		String uuid = (String) execContext.getVariable("uuid");
		
		if (uuid != null) {
			try {
				String actor = null;
				
				if (Config.ROLE_REVIEWER.equals(role)) {
					actor = ConfigDAO.getString(Config.PROPERTY_WORKFLOW_REVISION_REVIEWER, "okmAdmin");
				} else {
					actor = ConfigDAO.getString(Config.PROPERTY_WORKFLOW_REVISION_APPROVER, "okmAdmin");
				}
				
				assign.setActorId(actor);
				
				String path = OKMRepository.getInstance().getNodePath(token, uuid);
				String msg = "Task " + execContext.getTask().getName() + " assigned to " + actor;
				OKMNote.getInstance().add(token, path, msg);
				log.info(msg);
			} catch (Exception e) {
				log.error("Actor assigment error: " + e.getMessage());
			}
		} else {
			log.warn("Workflow has no associated node");
		}
	}
}
