package com.openkm.workflow;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.graph.def.ActionHandler;
import org.jbpm.graph.exe.ExecutionContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.openkm.api.OKMNote;
import com.openkm.api.OKMPropertyGroup;
import com.openkm.api.OKMRepository;
import com.openkm.module.db.stuff.DbSessionManager;

public class InitializeAction implements ActionHandler {
	private static final long serialVersionUID = 1L;
	private static Logger log = LoggerFactory.getLogger(InitializeAction.class);
	
	@Override
	public void execute(ExecutionContext execContext) throws Exception {
		log.info("execute({})", execContext.getTransition().getName());
		String token = DbSessionManager.getInstance().getSystemToken();
		String uuid = (String) execContext.getVariable("uuid");
		
		if (uuid != null) {
			try {
				String path = OKMRepository.getInstance().getNodePath(token, uuid);
				
				// Add note
				OKMNote.getInstance().add(token, path, "Workflow initialize");
				
				// Set status
				OKMPropertyGroup.getInstance().addGroup(token, path, Config.PROPERTY_GROUP);
				Map<String, String> props = new HashMap<String, String>();
				props.put(Config.PROPERTY_STATUS, Config.STATUS_PENDING);
				OKMPropertyGroup.getInstance().setPropertiesSimple(token, path, Config.PROPERTY_GROUP, props);
			} catch (Exception e) {
				log.error("Initialization error: " + e.getMessage());
			}
		} else {
			log.warn("Workflow has no associated node");
		}
		
		// Go to next node
		//execContext.getToken().signal();
	}
}
